#include "monster1.h"
#include <math.h>

extern int do_textures;
extern GLubyte Texture3[16][16][3];
extern GLubyte Texture2[128*128*3];

void
Monster1::draw()
	{
	int i, w;
	float phi;
	float theta;
	//static int t = 0;

	#define H (16.0)
	#define W (32.0)

	explode *= 1.5;
	int colideId;

	if(!did_explode)
		{
		colideId = badGuyController->getShotController()->isCollision(
				position[0], position[1], position[2] );
		}

	if ((colideId != -1) && (!did_explode)) {
		explode = 0.5;
		did_explode = 1;
	}

	if (explode > 100.0)
		return;

	// This is just a place holder
	glPushMatrix();

	if (do_textures) {
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
			GL_LINEAR_MIPMAP_LINEAR);
		gluBuild2DMipmaps(GL_TEXTURE_2D, 3, 128, 128,
			GL_RGB, GL_UNSIGNED_BYTE, Texture2);

		glEnable(GL_TEXTURE_2D);
	}

	glTranslatef( position[0], position[1], position[2] );
	glRotatef(90, 0, 1, 0);
	//glShadeModel(GL_FLAT);

	// This is just a place holder
	glColor3f( .7, .2, .2 );
	for (w = 0; w < W; w++) 
		{
   		glPushMatrix();
   		phi = ((w+0.5)/W)*(2.0*M_PI);
   		glTranslatef(explode*cos(phi), explode*sin(phi), 0.0);
   		glBegin(GL_TRIANGLE_STRIP);
   		for (i = 0; i < H+1; i++) 
			{
    	 	theta = (i/H)*(M_PI);
    	 	phi = (w/W)*(2.0*M_PI);
    	 	glVertex3f(
    	   	1.0*sin(theta)*cos(phi),
    	   	1.0*sin(theta)*sin(phi),
    	   	1.0*cos(theta));
    	 	phi = ((w+1)/W)*(2.0*M_PI);
    	 	glVertex3f(
    	   	1.0*sin(theta)*cos(phi),
    	   	1.0*sin(theta)*sin(phi),
    	   	1.0*cos(theta));
   			}
				glTexCoord2f(1.0*sin(theta+(M_PI/2.0))*cos(phi+(M_PI/2.0))*10.0,
					1.0*sin(theta+(M_PI/2.0))*sin(phi+(M_PI/2.0))*10.0);
   		glEnd();
   		glPopMatrix();
 		}

	glDisable(GL_TEXTURE_2D);

	glPopMatrix();

	}



