#include "shotcontroller.h"

void
ShotController::update()
	{
	for( int i = 0; i < MAX_SHOTS; i++ )
		{
		if ( shots[i] != NULL )
			{
			//printf("--shotz: %f i: %d, zloc: %f zlocstart: %f\n", 
			//		shots[i]->getZ() - shots[i]->getZStart(),i,
			//		shots[i]->getZ(), shots[i]->getZStart() );
			if ( shots[i]->getZ() < -30 )
				{
				//printf("shotcontroller->update: dequeuing %d\n",shotids[i]);
				tunnelQueue->deQueue(shotids[i]);
				delete shots[i];
				shots[i] = NULL;
				}
			else
				{
				shots[i]->setZ( shots[i]->getZ() - SHOT_SPEED );
				}
			// printf("done with update\n");	
			}
		}
	}

void 
ShotController::fire()	
	{
	currentShot = ( currentShot + 1 ) % MAX_SHOTS;
	if( shots[currentShot] != NULL ) delete shots[ currentShot ];
	shots[ currentShot ] = new Shot( 0, -1 * tunnelQueue->getZMove() );
	//printf("dequeueing shot: %d\n",shotids[currentShot]);
	if( shotids[currentShot] >= 0 ) 
			tunnelQueue->deQueue( shotids[currentShot] );
	// printf("queueing new shot\n");
	shotids[ currentShot ] = tunnelQueue->queue( shots[ currentShot ] );
	// printf("new shot: %d queued currentShot: %d\n",
			// shotids[ currentShot ],currentShot);
	}
	
int 
ShotController::isCollision( float objx, float objy, float objz )
	{
	//printf("\niscollision x: %f y: %f\n", objx, objy);
	float shotZrot, shotz, objZrot;
	if( objx > 0 && objy > 0 )
		{
		objZrot = atan( objy / objx );
		}
	else if ( objx < 0 && objy > 0 )	
		{
		objZrot = atan( (-1*objx) / objy ) + M_PI / 2;
		}
	else if ( objx < 0 && objy < 0 )
		{
		objZrot = atan( objy / objx ) + M_PI;
		}
	else if ( objx > 0 && objy < 0 )
		{
		objZrot = atan( objx / (-1*objy) ) + M_PI*3 / 2;
		}
	else if ( objx == 0 && objy > 0 )
		{
		objZrot = M_PI / 2;
		}
	else if ( objx == 0 && objy < 0 )
		{
		objZrot = M_PI*3 / 2;
		}
	else if ( objx > 0 && objy == 0 )
		{
		objZrot = 0;
		}
	else if ( objx < 0 && objy == 0 )
		{
		objZrot = M_PI;
		}
	else
		{
		printf("shotcontroller: Shouldn't be here\n");
		}
		
	objZrot *= 180/3.1415;
	while( objZrot < 0 ) objZrot += 360;
	while( objZrot > 360 ) objZrot -= 360;
	//printf("objz: %f objZrot: %f\n",objz,objZrot);

	for ( int i=0; i < MAX_SHOTS; i++ )
		{
		if ( shots[i] == NULL ) continue;
		shotZrot = shots[i]->getZRotStart();
		// change system
		//printf("original shotZrot %f\n", shotZrot);
		shotZrot *= -1;
		shotZrot -= 90;
		while( shotZrot < 0 ) shotZrot += 360;
		while( shotZrot > 360 ) shotZrot -= 360;
		shotz = shots[i]->getZStart() + shots[i]->getZ();
		//printf("shotz: %f shotZrot: %f\n", shotz, shotZrot);
		
		// Check if it 'collided'
		// This doesn't work around '0' and '360' very well...
		float lowrot = objZrot - HIT_TOL_ZROT;
		if(lowrot < 0) lowrot += 360;
		float highrot = objZrot + HIT_TOL_ZROT;
		if(highrot > 360) highrot -= 360;
		
		if ( shotZrot > lowrot &&
				shotZrot < highrot &&
				shotz > objz - HIT_TOL_ZLOC &&
				shotz < objz + HIT_TOL_ZLOC )
			{
			//printf("i: %d shotids: %d\n",i,shotids[i]);
			delete shots[i];
			tunnelQueue->deQueue( shotids[i] );
			shots[i] = NULL;
			return shotids[i];
			}
		}
	return -1;
	}
