
#include "tristrip.h"

extern GLubyte Texture1[128*128*3];
extern int do_textures;

/*
void tristrip()
	{
	glBegin( GL_TRIANGLE_STRIP );
	
		glColor3f( 0.2, 1.0, 0.2 );
	glVertex3f( 0.8, 0.0,    0 );
	glVertex3f( 0.0, 0.0, -0.2 );
	glVertex3f( 0.8, 0.8, -0.4 );
		glColor3f( 1.0, 0.2, 0.2 );
	glVertex3f( 0.0, 0.8, -0.6 );
		glColor3f( 0.2, 0.2, 1.0 );
	glVertex3f( 0.8, 1.6, -1.0 );
		glColor3f( 1.0, 0.2, 1.0 );
	glVertex3f( 0.0, 1.6, -1.6 );
		glColor3f( 0.2, 1.0, 0.2 );
	glVertex3f( 0.8, 2.4, -2.6 );
		glColor3f( 1.0, 0.2, 0.2 );
	glVertex3f( 0.0, 2.4, -4.2 );
		glColor3f( 0.2, 0.2, 1.0 );
	glVertex3f( 0.8, 3.2, -5.8 );
		glColor3f( 1.0, 0.2, 1.0 );
	glVertex3f( 0.0, 3.2, -6.8 );
	
	glEnd();
	}
*/

void TriStrip::draw()
	{
	glPushMatrix();

	if (do_textures) {
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
			GL_LINEAR_MIPMAP_LINEAR);
		gluBuild2DMipmaps(GL_TEXTURE_2D, 3, 128, 128,
			GL_RGB, GL_UNSIGNED_BYTE, Texture1);

		glEnable(GL_TEXTURE_2D);
	}

	glBegin( GL_TRIANGLE_STRIP );
	for ( int i = 0; i < 2 * (TUNNEL_SIDES + 1); i++ )
		{
		//printf( "TriStrip::draw stripCoords: %f %f %f i: %d id: %d\n", 
		//		stripCoords[ i ],
		//		stripCoords[ i + 2*(TUNNEL_SIDES + 1) ], 
		//		stripCoords[ i + 4*(TUNNEL_SIDES + 1) ], i, idnum );
		
		//printf("TriStrip::draw colours: %f %f %f i: %d\n", 
		//		colours[ i ],
		//		colours[ i + 2*(TUNNEL_SIDES + 1) ],
		//		colours[ i + 4*(TUNNEL_SIDES + 1) ], i );

		//glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 0.1);
		GLfloat specular[4];
		specular[0] = specular[1] = specular[2] = 0.1;
		specular[3] = 1;
		glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, specular);

		glColor3f( colours[ i ], 
					colours[ i + 2*(TUNNEL_SIDES + 1) ],
					colours[ i + 4*(TUNNEL_SIDES + 1) ] );
		
		glVertex3f( stripCoords[ i ], 
					stripCoords[ i + 2*(TUNNEL_SIDES + 1) ], 
					stripCoords[ i + 4*(TUNNEL_SIDES + 1) ] );
		glTexCoord2f(stripCoords[i], stripCoords[i+2*(TUNNEL_SIDES+1)]);
		}
	glEnd();	
	glDisable(GL_TEXTURE_2D);
	//printf("drew\n");
	glPopMatrix();
	}
