#ifndef TRISTRIP_H
#define TRISTRIP_H 1

#include "main.h"
#include "drawable.h"

class TriStrip;

class TriStrip: public DrawableObj
	{
	public:
	TriStrip()
		{
		idnum = -1;
		stripCoords = new float [ 3 * 2 * (TUNNEL_SIDES + 1) ];
		colours = new float [ 3 * 2 * (TUNNEL_SIDES + 1) ];
		frontCoordAvg = new float [3];
		backCoordAvg = new float [3];
		for( int i = 0; i < 3; i++ )
			{
			frontCoordAvg[i] = 0;
			backCoordAvg[i] = 0;
			}
		}

	void setStripCoords( float * newCoords )
		{
		delete stripCoords;
		stripCoords = newCoords;
		// printf("setting contents->strip %d\n", stripCoords);
		}

	void setColours( float * newColours )
		{
		delete colours;
		colours = newColours;
		}

	float * getStripCoords()
		{
		return stripCoords;
		}
	
	void setIdnum( int id )
		{
		idnum = id;
		}

	int getIdnum()
		{
		return idnum;
		}
	
	void draw();

	void setFrontCoordAvg( float * newavg )
		{
		delete frontCoordAvg;
		frontCoordAvg = newavg;
		}

	void setBackCoordAvg( float * newavg )
		{
		delete backCoordAvg;
		backCoordAvg = newavg;
		}

	float * getFrontCoordAvg()
		{
		return frontCoordAvg;
		}

	float * getBackCoordAvg()
		{
		return backCoordAvg;
		}
	
	private:
	float * stripCoords;
	float * colours;
	int idnum;
	float * frontCoordAvg;
	float * backCoordAvg;
	};

#endif
