#ifndef TUNNEL_H
#define TUNNEL_H 1

#include "main.h"
#include "tunnelqueue.h"
#include "tristrip.h"
#include <math.h>

class Tunnel
	{
	public:
	Tunnel( TunnelQueue * newQueue )
		{
		timer = 0;
		stripIdPtr = 0;
		tunnelQueue = newQueue;
		stripCoords = new float [ 3 * 2 * (TUNNEL_SIDES + 1) ];
		colours = new float [ 3 * 2 * (TUNNEL_SIDES + 1) ];
		frontCoordAvg = new float [3];
		backCoordAvg = new float [3];
		genFirstSides();
		for ( int i = 0; i < TUNNEL_LENGTH; i++ )
			{
			stripIds[i] = -1;
			}
		for ( int i = 0; i < 3; i++ )
			{
			frontCoordAvg[i] = 0;
			backCoordAvg[i] = 0;
			}
		}
			
	void update();
	void genSides();
	void genFirstSides();
	void genTriStripCoords();
	void genColours();
	void pointRandomize();

	private:
	TunnelQueue * tunnelQueue;
	int addDelay;
	float lastPoints[3][ TUNNEL_SIDES + 1 ];
	float newPoints[3][ TUNNEL_SIDES + 1 ];
	float initPoints[3][ TUNNEL_SIDES + 1 ];
	float * colours;
	float * stripCoords;
	float * frontCoordAvg;
	float * backCoordAvg;
	int stripIds[ TUNNEL_LENGTH ];
	int stripIdPtr;
	int timer;
	};

#endif
