#ifndef TUNNELNODE_H
#define TUNNELNODE_H 1

#include "main.h"
#include "drawable.h"

class TunnelNode;

// tunnel queue node, contains one triangle strip
class TunnelNode
	{
	public:
	TunnelNode( int newidnum, DrawableObj * newcontents )
		{
		idnum = newidnum;
		//printf("idnum set to: %d\n", idnum);
		contents = newcontents;
		prev = NULL;
		next = NULL;
		}

	void setPointers( TunnelNode * newprev, TunnelNode * newnext )
		{
		prev = newprev;
		next = newnext;
		}

	void setPrev( TunnelNode * newprev )
		{
		prev = newprev;
		}

	TunnelNode * getPrev()
		{
		return prev;
		}

	void setNext( TunnelNode * newnext )
		{
		next = newnext;
		}

	TunnelNode * getNext()
		{
		return next;
		}

	void setContents( DrawableObj * newcontents )
		{
		contents = newcontents;
		}

	DrawableObj * getContents()
		{
		return contents;
		}

	int getIdnum()
		{
		return idnum;
		}

	private:
	TunnelNode();
	TunnelNode * next;
	TunnelNode * prev;
	DrawableObj * contents;
	int idnum;
	};

#endif
