
#include "tunnelqueue.h"

int TunnelQueue::queue( DrawableObj * newcontents )
	{
	currentIdnum++;
	//printf("tunnelqueue: queueing %d\n",currentIdnum);
	TunnelNode* node = new TunnelNode( currentIdnum, newcontents );
	
	if ( head == NULL )
		{
		head = node;
		tail = node;
		return currentIdnum;
		}
		
	tail->setNext( node );
	node->setPrev( tail );
	tail = node;
	//printf("done queueing %d\n", currentIdnum);
	return currentIdnum;
	}

void TunnelQueue::deQueue( int idnum )
	{
	//printf("tunnelqueue: dequeueing %d\n",idnum);
	if ( idnum < 0 )
		{
		return;
		}
	TunnelNode* node;
	if ( head == NULL ) return;
	node = getNode( idnum, head );
	if ( node == NULL ) 
		{
		return;
		}

	if ( node == head )
		{
		head = node->getNext();
		if( head != NULL )
			{
			head->setPrev( NULL );
			if ( head->getNext() == NULL )
				{
				tail = head;
				}
			}
		else
			{
			// head is NULL
			tail = head;
			}
		delete node;
		return;
		}
	
	if ( node == tail )
		{
		tail = tail->getPrev();
		tail->setNext( NULL );
		delete node;
		return;
		}

	node->getNext()->setPrev( node->getPrev() );
	node->getPrev()->setNext( node->getNext() );
	delete node;
	}

TunnelNode* TunnelQueue::getNode( int idnum, TunnelNode* node )
	{
	//printf( "idnum %d node: %d\n",idnum, node);
	if ( node == NULL ) return NULL;
	if ( node->getIdnum() == idnum ) return node;
	return getNode( idnum, node->getNext() );
	}

void TunnelQueue::drawAll()
	{
	if ( head == NULL ) return;
	// The magic tunnel moving formula:
	zmove = ( ( (float)frame/(ADD_SIDE_DELAY+1) ) 
					- (TUNNEL_LENGTH) ) * STRIP_DEPTH;
	// printf("drawall frame: %d zmove: %f\n", frame, zmove );
	glTranslatef( 0, 0, zmove );
	drawAll( head );
	//printf("frame %d\n", frame );
	}

void TunnelQueue::drawAll( TunnelNode * node )
	{
	// printf("drawAll node->contents->strip %d, id: %d\n", node->getContents()->getStripCoords(), node->getIdnum() );
	if ( node != NULL )
		{
		node->getContents()->draw();
		if ( node != tail )
			{
			drawAll( node->getNext() );
			}
		}	
	}	
